=== debian/changelog ===
rgbds (0.9.3-1) unstable; urgency=medium

  * Initial release (Closes: #984927)

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 08 Jul 2025 09:06:16 +0200
