=== debian/control ===
Source: rgbds
Section: devel
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake, bison, pkgconf, libpng-dev
Standards-Version: 4.7.2
Homepage: https://rgbds.gbdev.io
Vcs-Browser: https://salsa.debian.org/twolife/rgbds
Vcs-Git: https://salsa.debian.org/twolife/rgbds.git

Package: rgbds
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Game Boy assembly toolchain
 The Rednex Game Boy Development System provides tools to compile homebrew
 Game Boy ROMs. It consists of:
  - rgbasm (assembler)
  - rgblink (linker)
  - rgbfix (checksum/header fixer)
  - rgbgfx (PNG‐to‐Game Boy graphics converter)
