=== debian/watch ===
version=4

opts="pgpmode=none"
https://github.com/gbdev/rgbds/tags .*/[vV]?(\d[^\s+]+)\.tar\.gz
