=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 .SUFFIXES:
 .SUFFIXES: .cpp .y .o
 
-.PHONY: all clean install checkdiff develop debug profile coverage iwyu mingw32 mingw64 wine-shim dist
+.PHONY: all clean install checkdiff develop debug profile coverage tidy iwyu mingw32 mingw64 wine-shim dist
 
 # User-defined variables
 
@@ -49,7 +49,14 @@
 
 all: rgbasm rgblink rgbfix rgbgfx
 
+common_obj := \
+	src/extern/getopt.o \
+	src/diagnostics.o \
+	src/usage.o
+
 rgbasm_obj := \
+	${common_obj} \
+	src/asm/actions.o \
 	src/asm/charmap.o \
 	src/asm/fixpoint.o \
 	src/asm/format.o \
@@ -64,9 +71,7 @@
 	src/asm/section.o \
 	src/asm/symbol.o \
 	src/asm/warning.o \
-	src/extern/getopt.o \
 	src/extern/utf8decoder.o \
-	src/error.o \
 	src/linkdefs.o \
 	src/opmath.o \
 	src/util.o
@@ -74,7 +79,10 @@
 src/asm/lexer.o src/asm/main.o: src/asm/parser.hpp
 
 rgblink_obj := \
+	${common_obj} \
 	src/link/assign.o \
+	src/link/lexer.o \
+	src/link/layout.o \
 	src/link/main.o \
 	src/link/object.o \
 	src/link/output.o \
@@ -83,34 +91,36 @@
 	src/link/sdas_obj.o \
 	src/link/section.o \
 	src/link/symbol.o \
-	src/extern/getopt.o \
+	src/link/warning.o \
 	src/extern/utf8decoder.o \
-	src/error.o \
 	src/linkdefs.o \
 	src/opmath.o \
 	src/util.o
 
-src/link/main.o: src/link/script.hpp
+src/link/lexer.o src/link/main.o: src/link/script.hpp
 
 rgbfix_obj := \
+	${common_obj} \
 	src/fix/main.o \
-	src/extern/getopt.o \
-	src/error.o
+	src/fix/mbc.o \
+	src/fix/warning.o
 
 rgbgfx_obj := \
+	${common_obj} \
+	src/gfx/color_set.o \
 	src/gfx/main.o \
 	src/gfx/pal_packing.o \
 	src/gfx/pal_sorting.o \
 	src/gfx/pal_spec.o \
+	src/gfx/png.o \
 	src/gfx/process.o \
-	src/gfx/proto_palette.o \
 	src/gfx/reverse.o \
 	src/gfx/rgba.o \
-	src/extern/getopt.o \
-	src/error.o
+	src/gfx/warning.o \
+	src/util.o
 
 rgbasm: ${rgbasm_obj}
-	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgbasm_obj} ${REALCXXFLAGS} src/version.cpp -lm
+	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgbasm_obj} ${REALCXXFLAGS} src/version.cpp
 
 rgblink: ${rgblink_obj}
 	$Q${CXX} ${REALLDFLAGS} -o $@ ${rgblink_obj} ${REALCXXFLAGS} src/version.cpp
@@ -142,6 +152,8 @@
 	$Qtouch $@
 
 # Only RGBGFX uses libpng (POSIX make doesn't support pattern rules to cover all these)
+src/gfx/color_set.o: src/gfx/color_set.cpp
+	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/main.o: src/gfx/main.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/pal_packing.o: src/gfx/pal_packing.cpp
@@ -150,9 +162,9 @@
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/pal_spec.o: src/gfx/pal_spec.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
+src/gfx/png.o: src/gfx/png.cpp
+	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/process.o: src/gfx/process.cpp
-	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
-src/gfx/proto_palette.o: src/gfx/proto_palette.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
 src/gfx/reverse.o: src/gfx/reverse.cpp
 	$Q${CXX} ${REALCXXFLAGS} ${PNGCFLAGS} -c -o $@ $<
@@ -163,7 +175,6 @@
 	$Q${CXX} ${REALCXXFLAGS} -c -o $@ $<
 
 # Target used to remove all files generated by other Makefile targets
-
 clean:
 	$Q${RM} rgbasm rgbasm.exe
 	$Q${RM} rgblink rgblink.exe
@@ -177,7 +188,6 @@
 	$Q${RM} test/gfx/randtilegen test/gfx/rgbgfx_test
 
 # Target used to install the binaries and man pages.
-
 install: all
 	$Qinstall -d ${DESTDIR}${bindir}/ ${DESTDIR}${mandir}/man1/ ${DESTDIR}${mandir}/man5/ ${DESTDIR}${mandir}/man7/
 	$Qinstall ${STRIP} -m ${BINMODE} rgbasm ${DESTDIR}${bindir}/rgbasm${SUFFIX}
@@ -189,15 +199,13 @@
 	$Qinstall -m ${MANMODE} man/rgbds.7 man/gbz80.7 ${DESTDIR}${mandir}/man7/
 
 # Target used to check for suspiciously missing changed files.
-
 checkdiff:
 	$Qcontrib/checkdiff.bash `git merge-base HEAD ${BASE_REF}`
 
-# This target is used during development in order to prevent adding new issues
-# to the source code. All warnings are treated as errors in order to block the
-# compilation and make the continous integration infrastructure return failure.
+# Target used in development to prevent adding new issues to the source code.
+# All warnings are treated as errors to block the compilation and make the
+# continous integration infrastructure return failure.
 # The rationale for some of the flags is documented in the CMakeLists.
-
 develop:
 	$Q${MAKE} WARNFLAGS="${WARNFLAGS} -Werror -Wextra \
 		-Walloc-zero -Wcast-align -Wcast-qual -Wduplicated-branches -Wduplicated-cond \
@@ -210,26 +218,27 @@
 		-fsanitize=float-divide-by-zero" \
 		CXXFLAGS="-ggdb3 -Og -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to more easily debug with gdb.
-
+# Target used in development to debug with gdb.
 debug:
 	$Qenv ${MAKE} \
 		CXXFLAGS="-ggdb3 -O0 -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to more easily profile with callgrind.
-
+# Target used in development to profile with callgrind.
 profile:
 	$Qenv ${MAKE} \
 		CXXFLAGS="-ggdb3 -O3 -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to inspect code coverage with gcov.
-
+# Target used in development to inspect code coverage with gcov.
 coverage:
 	$Qenv ${MAKE} \
 		CXXFLAGS="-ggdb3 -Og --coverage -fno-omit-frame-pointer -fno-optimize-sibling-calls"
 
-# This target is used during development in order to remove unused `#include` headers.
-
+# Target used in development to check code with clang-tidy.
+# Requires Bison-generated header files to exist.
+tidy: src/asm/parser.hpp src/link/script.hpp
+	$Qclang-tidy -p . $$(find src -name '*.cpp')
+
+# Target used in development to remove unused `#include` headers.
 iwyu:
 	$Qenv ${MAKE} \
 		CXX="include-what-you-use" \
