=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,9 @@
 configure_file(version.cpp _version.cpp ESCAPE_QUOTES)
 
 set(common_src
-    "error.cpp"
     "extern/getopt.cpp"
+    "diagnostics.cpp"
+    "usage.cpp"
     "_version.cpp"
     )
 
@@ -34,6 +35,7 @@
 
 set(rgbasm_src
     "${BISON_ASM_PARSER_OUTPUT_SOURCE}"
+    "asm/actions.cpp"
     "asm/charmap.cpp"
     "asm/fixpoint.cpp"
     "asm/format.cpp"
@@ -53,26 +55,11 @@
     "util.cpp"
     )
 
-set(rgbfix_src
-    "fix/main.cpp"
-    )
-
-set(rgbgfx_src
-    "gfx/main.cpp"
-    "gfx/pal_packing.cpp"
-    "gfx/pal_sorting.cpp"
-    "gfx/pal_spec.cpp"
-    "gfx/process.cpp"
-    "gfx/proto_palette.cpp"
-    "gfx/reverse.cpp"
-    "gfx/rgba.cpp"
-    "extern/getopt.cpp"
-    "error.cpp"
-    )
-
 set(rgblink_src
     "${BISON_LINKER_SCRIPT_PARSER_OUTPUT_SOURCE}"
     "link/assign.cpp"
+    "link/lexer.cpp"
+    "link/layout.cpp"
     "link/main.cpp"
     "link/object.cpp"
     "link/output.cpp"
@@ -80,9 +67,30 @@
     "link/sdas_obj.cpp"
     "link/section.cpp"
     "link/symbol.cpp"
+    "link/warning.cpp"
     "extern/utf8decoder.cpp"
     "linkdefs.cpp"
     "opmath.cpp"
+    "util.cpp"
+    )
+
+set(rgbfix_src
+    "fix/main.cpp"
+    "fix/mbc.cpp"
+    "fix/warning.cpp"
+    )
+
+set(rgbgfx_src
+    "gfx/color_set.cpp"
+    "gfx/main.cpp"
+    "gfx/pal_packing.cpp"
+    "gfx/pal_sorting.cpp"
+    "gfx/pal_spec.cpp"
+    "gfx/png.cpp"
+    "gfx/process.cpp"
+    "gfx/reverse.cpp"
+    "gfx/rgba.cpp"
+    "gfx/warning.cpp"
     "util.cpp"
     )
