=== debian/changelog ===
rgbds (0.9.4-1) unstable; urgency=medium

  * New upstream release

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 12 Oct 2025 11:46:36 +0200
