=== debian/watch ===
Version: 5
Template: Github
Owner: gbdev
Project: rgbds
Uversion-Mangle: auto
