=== debian/changelog ===
rgbds (1.0.0-2) unstable; urgency=medium

  * fix FTBFS on alpha.

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 04 Nov 2025 12:20:00 +0100

rgbds (1.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Tue, 04 Nov 2025 08:30:38 +0100
