=== debian/control ===
--- 
+++ 
@@ -3,12 +3,11 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sébastien Noel <sebastien@twolife.be>
-Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13), cmake, bison, pkgconf, libpng-dev
 Standards-Version: 4.7.2
 Homepage: https://rgbds.gbdev.io
-Vcs-Browser: https://salsa.debian.org/twolife/rgbds
-Vcs-Git: https://salsa.debian.org/twolife/rgbds.git
+Vcs-Browser: https://salsa.debian.org/games-team/rgbds
+Vcs-Git: https://salsa.debian.org/games-team/rgbds.git
 
 Package: rgbds
 Architecture: any
