=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,11 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# Work around FTBFS on Alpha (assembler error "No lda !gpdisp!")
+ifneq (,$(filter $(DEB_HOST_ARCH),alpha))
+  export DEB_CXXFLAGS_MAINT_APPEND += -O1
+endif
 
 %:
 	dh $@ --buildsystem=cmake
