=== debian/changelog ===
rgbds (1.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 05 Jan 2026 11:56:43 +0100
