=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: rgbds
 Section: devel
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sébastien Noel <sebastien@twolife.be>
 Build-Depends: debhelper-compat (= 13), cmake, bison, pkgconf, libpng-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://rgbds.gbdev.io
 Vcs-Browser: https://salsa.debian.org/games-team/rgbds
 Vcs-Git: https://salsa.debian.org/games-team/rgbds.git
